diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/AUTHORS ns-3.35/AUTHORS
--- ns-3.34/AUTHORS	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/AUTHORS	2021-10-01 13:26:47.000000000 -0700
@@ -33,6 +33,7 @@
 Biljana Bojovic (bbojovic@cttc.es)
 Elena Borovkova (borokovaes@iitp.ru)
 Rahul Bothra (rrbothra@gmail.com)
+Caleb Bowers (caleb.bowers@nel.navy.mil, cbowers1020@gmail.com)
 Pavel Boyko (boyko@iitp.ru)
 Matthew Bradbury (matt-bradbury@live.co.uk)
 Dan Broyles (muxman@sbcglobal.net)
@@ -77,6 +78,7 @@
 Jahanzeb Farooq (Jahanzeb.Farooq@inria.fr, Jahanzeb.Farooq@gmail.com)
 Luca Favatella (slackydeb@gmail.com)
 Kim Ferrari (ferrari2@llnl.gov)
+Gabriel Ferreira (gabrielcarvfer@gmail.com)
 Margherita Filippetti (morag87@gmail.com)
 Pedro Fortuna (pedro.fortuna@inescporto.pt)
 Juliana Freitag Borin (juliana.freitag@gmail.com)
@@ -110,6 +112,7 @@
 Kristian A. Hiorth (kristahi@ifi.uio.no)
 Hrishikesh Hiraskar (hrishihirakar@gmail.com)
 Kim Højgaard-Hansen (kimrhh@gmail.com)
+Philip Hönnecke (p.hoennecke@tu-braunschweig.de)
 Chris Hood (chood8@gatech.edu)
 Blake Hurd (naimorai@gmail.com)
 Pasquale Imputato (p.imputato@gmail.com)
@@ -146,6 +149,7 @@
 Alexander Krotov (ilabdsf@yandex.ru)
 Deepak Kumaraswamy (deepakkavoor99@gmail.com)
 Mathieu Lacage (mathieu.lacage@inria.fr)
+Sandra Lagen (sandra.lagen@cttc.es)
 Emmanuelle Laprise (emmmanuelle.laprise@bluekazoo.ca)
 Harsh Lara (harshapplefan@gmail.com)
 Mattia Lecci (mattia.lecci@gmail.com)
@@ -218,6 +222,7 @@
 Michele Polese (michele.polese@gmail.com)
 Ovidiu Poncea (ovidiu.poncea@cs.pub.ro)
 Anna Poon (poon2@llnl.gov)
+Gauri Prasad
 Vikas Pushkar (vikaskupushkar@gmail.com)
 Alberto Gallegos Ramonet (ramonet@fc.ritsumei.ac.jp)
 Manoj Kumar Rana (manoj24.rana@gmail.com)
@@ -249,6 +254,7 @@
 Chappidi Yoga Satwik (satwik.chappidi@iitkgp.ac.in)
 Robert R. Schmidt (rschmi@gmx.net)
 Florian Schmidt (Florian.Schmidt@cs.rwth-aachen.de)
+Michael Scoggin (mpscogg@sandia.gov)
 Surya Seetharaman (suryaseetharaman.9@gmail.com)
 Guillaume Seguin (guillaume.seguin@inria.fr)
 Ioannis Selinis (selinis.g@gmail.com)
@@ -271,6 +277,7 @@
 YunQiang Su (wzssyqa@gmail.com)
 Brian Swenson (bswenson3@gatech.edu)
 Lalith Suresh  (suresh.lalith@gmail.com)
+Szymon Szott (szott@kt.agh.edu.pl)
 Mohit P. Tahiliani (tahiliani.nitk@gmail.com)
 Rohit P. Tahiliani (tahiliar@tcd.ie)
 Dave Taht (dave.taht@bufferbloat.net)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/contrib/wscript ns-3.35/contrib/wscript
--- ns-3.34/contrib/wscript	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/contrib/wscript	2021-10-01 13:26:47.000000000 -0700
@@ -284,10 +284,8 @@
             pymod.env.append_value('LINKFLAGS', '-Wl,-Bdynamic,--no-whole-archive')
     defines = list(pymod.env['DEFINES'])
     defines.extend(['NS_DEPRECATED=', 'NS3_DEPRECATED_H'])
+    defines.extend(['NS_DEPRECATED_3_35=', 'NS3_DEPRECATED_H'])
     defines.extend(['NS_DEPRECATED_3_34=', 'NS3_DEPRECATED_H'])
-    defines.extend(['NS_DEPRECATED_3_32=', 'NS3_DEPRECATED_H'])
-    defines.extend(['NS_DEPRECATED_3_31=', 'NS3_DEPRECATED_H'])
-    defines.extend(['NS_DEPRECATED_3_30=', 'NS3_DEPRECATED_H'])
     if Utils.unversioned_sys_platform() == 'win32':
         try:
             defines.remove('_DEBUG') # causes undefined symbols on win32
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/doc/doxygen.conf ns-3.35/doc/doxygen.conf
--- ns-3.34/doc/doxygen.conf	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/doc/doxygen.conf	2021-10-01 13:26:47.000000000 -0700
@@ -2214,6 +2214,7 @@
                          NS3_BUILD_PROFILE_DEBUG \
                          NS3_BUILD_PROFILE_RELEASE \
                          NS3_BUILD_PROFILE_OPTIMIZED \
+                         DOXYGEN_SHOULD_SKIP_THIS \
                          INT64X64_USE_CAIRO \
                          INT64X64_USE_DOUBLE \
                          INT64X64_USE_CAIRO \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/examples/tcp/tcp-validation.cc ns-3.35/examples/tcp/tcp-validation.cc
--- ns-3.34/examples/tcp/tcp-validation.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/examples/tcp/tcp-validation.cc	2021-10-01 13:26:47.000000000 -0700
@@ -181,18 +181,22 @@
       double cwnd = static_cast<double> (newCwnd) / 1448;
       if ((now > 5.43) && (now < 5.465) && (cwnd < 500))
         {
+          NS_LOG_WARN ("now " << Now ().As (Time::S) << " cwnd " << cwnd << " (expected >= 500)");
           g_validationFailed = true;
         }
       else if ((now > 5.795) && (now < 6) && (cwnd > 190))
         {
+          NS_LOG_WARN ("now " << Now ().As (Time::S) << " cwnd " << cwnd << " (expected <= 190)");
           g_validationFailed = true;
         }
-      else if ((now > 14) && (now < 14.328) && (cwnd < 225))
+      else if ((now > 14) && (now < 14.197) && (cwnd < 224))
         {
+          NS_LOG_WARN ("now " << Now ().As (Time::S) << " cwnd " << cwnd << " (expected >= 224)");
           g_validationFailed = true;
         }
-      else if ((now > 17) && (now < 18.2) && (cwnd < 225))
+      else if ((now > 17) && (now < 18.026) && (cwnd < 212))
         {
+          NS_LOG_WARN ("now " << Now ().As (Time::S) << " cwnd " << cwnd << " (expected >= 212)");
           g_validationFailed = true;
         }
     }
@@ -211,14 +215,17 @@
       double now = Simulator::Now ().GetSeconds ();
       if ((now < 7.5) && (alpha < 0.1))
         {
+          NS_LOG_WARN ("now " << Now ().As (Time::S) << " alpha " << alpha << " (expected >= 0.1)");
           g_validationFailed = true;
         }
       else if ((now > 11) && (now < 30) && (alpha > 0.01))
         {
+          NS_LOG_WARN ("now " << Now ().As (Time::S) << " alpha " << alpha << " (expected <= 0.01)");
           g_validationFailed = true;
         }
       else if ((now > 34) && (alpha < 0.015) && (alpha > 0.025))
         {
+          NS_LOG_WARN ("now " << Now ().As (Time::S) << " alpha " << alpha << " (expected 0.015 <= alpha <= 0.025)");
           g_validationFailed = true;
         }
     }
@@ -227,10 +234,12 @@
       double now = Simulator::Now ().GetSeconds ();
       if ((now > 5.6) && (alpha > 0.1))
         {
+          NS_LOG_WARN ("now " << Now ().As (Time::S) << " alpha " << alpha << " (expected <= 0.1)");
           g_validationFailed = true;
         }
       if ((now > 7) && ((alpha > 0.09) || (alpha < 0.055)))
         {
+          NS_LOG_WARN ("now " << Now ().As (Time::S) << " alpha " << alpha << " (expected 0.09 <= alpha <= 0.055)");
           g_validationFailed = true;
         }
     }
@@ -351,14 +360,17 @@
       double now = Simulator::Now ().GetSeconds ();
       if ((now < 14) && (throughput > 20))
         {
+          NS_LOG_WARN ("now " << Now ().As (Time::S) << " throughput " << throughput << " (expected <= 20)");
           g_validationFailed = true;
         }
       if ((now < 30) && (throughput > 48))
         {
+          NS_LOG_WARN ("now " << Now ().As (Time::S) << " throughput " << throughput << " (expected <= 48)");
           g_validationFailed = true;
         }
       if ((now > 32) && ((throughput < 47.5) || (throughput > 48.5)))
         {
+          NS_LOG_WARN ("now " << Now ().As (Time::S) << " throughput " << throughput << " (expected 47.5 <= throughput <= 48.5)");
           g_validationFailed = true;
         }
     }
@@ -367,6 +379,7 @@
       double now = Simulator::Now ().GetSeconds ();
       if ((now > 5.6) && ((throughput < 48) || (throughput > 49)))
         {
+          NS_LOG_WARN ("now " << Now ().As (Time::S) << " throughput " << throughput << " (expected 48 <= throughput <= 49)");
           g_validationFailed = true;
         }
     }
@@ -628,8 +641,15 @@
   Config::SetDefault ("ns3::TcpSocketBase::UseEcn", StringValue ("On"));
 
   // Report on configuration
-  NS_LOG_DEBUG ("first TCP: " << firstTcpTypeId.GetName () << "; second TCP: " << secondTcpTypeId.GetName () << "; queue: " << queueTypeId.GetName () << "; ceThreshold: " << ceThreshold.GetSeconds () * 1000 << "ms");
-
+  if (enableSecondTcp)
+    {
+      NS_LOG_DEBUG ("first TCP: " << firstTcpTypeId.GetName () << "; second TCP: " << secondTcpTypeId.GetName () << "; queue: " << queueTypeId.GetName () << "; ceThreshold: " << ceThreshold.GetSeconds () * 1000 << "ms");
+    }
+  else 
+    {
+      NS_LOG_DEBUG ("first TCP: " << firstTcpTypeId.GetName () << "; queue: " << queueTypeId.GetName () << "; ceThreshold: " << ceThreshold.GetSeconds () * 1000 << "ms");
+    }
+  
   // Write traces only if we are not in validation mode (g_validate == "")
   std::ofstream pingOfStream;
   std::ofstream firstTcpRttOfStream;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/examples/wireless/wifi-spectrum-saturation-example.cc ns-3.35/examples/wireless/wifi-spectrum-saturation-example.cc
--- ns-3.34/examples/wireless/wifi-spectrum-saturation-example.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/examples/wireless/wifi-spectrum-saturation-example.cc	2021-10-01 13:26:47.000000000 -0700
@@ -60,7 +60,7 @@
 // attributes, global values, and default values typically available:
 //
 //    --simulationTime:  Simulation time in seconds [10]
-//    --distance:        meters separation between nodes [50]
+//    --distance:        meters separation between nodes [1]
 //    --index:           restrict index to single value between 0 and 31 [256]
 //    --wifiType:        select ns3::SpectrumWifiPhy or ns3::YansWifiPhy [ns3::SpectrumWifiPhy]
 //    --errorModelType:  select ns3::NistErrorRateModel or ns3::YansErrorRateModel [ns3::NistErrorRateModel]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/RELEASE_NOTES ns-3.35/RELEASE_NOTES
--- ns-3.34/RELEASE_NOTES	2021-07-14 10:32:18.000000000 -0700
+++ ns-3.35/RELEASE_NOTES	2021-10-01 13:27:51.000000000 -0700
@@ -9,6 +9,76 @@
 Consult the file CHANGES.html for more detailed information about changed
 API and behavior across ns-3 releases.
 
+Release 3.35
+============
+
+Availability
+------------
+This release is available from:
+https://www.nsnam.org/release/ns-allinone-3.35.tar.bz2
+
+Supported platforms
+-------------------
+This release is intended to work on systems with the following minimal
+requirements (Note: not all ns-3 features are available on all systems):
+- g++-7 or later, or LLVM/clang++-8 or later
+- Python 3.6 or later
+- (macOS only) Xcode 11 or later
+
+Python API scanning only works for Python versions 3.6 through 3.8, due to
+an upstream toolchain limitation.
+
+This release has been tested on the following systems:
+- Fedora 34 with g++-11.2.1 and clang++-12.0.1; Python 3.9.7
+- Fedora 33 with g++-10.3.1 and clang++-11.0.0; Python 3.9.6
+- Ubuntu 21.04 with g++-11.1.and clang++-12.0.0; Python 3.9.5
+- Ubuntu 20.04 with g++-9.3.0 and clang++-10.0.0; Python 3.8.10
+- Ubuntu 18.04 with g++-7.5.0 and clang++-6.0.0; Python 3.6.9
+- macOS 10.15.7 (Catalina) with Xcode 12.4 (Apple clang-1200.0.32.29, Python 3.9.1)
+
+This release has discontinued support for g++-5 and g++-6 compilers, and
+for macOS Xcode 10.
+
+New user-visible features
+-------------------------
+ns-3 has switched to the C++17 standard by default, although the more
+advanced constructs (beyond C++11) are generally avoided in the header files,
+to stay compatible with the Python API scanning framework.
+
+- (antenna) Extend UniformPlanarArray to have a configurable polarization slant angle
+- (buildings) Add example program demonstrating group mobility with the buildings-aware random walk mobility model, and a script to animate the group motion.
+- (config-store) OBSOLETE Attributes are not anymore saved.
+- (config-store) New ConfigStore::SaveDeprecated Attribute (default false) to avoid to save DEPRECATED attributes.
+- (core) Add TracedCallback::IsEmpty to know if a TracedCallback has any callback associated.
+- (core) Add std::hash<ns3::Ptr<T>> to allow seamless use of Ptr as key in unordered_maps.
+- (core) Print available values on EnumChecker::GetValue () error
+- (internet) Added getters and setters for source and destination in Ipv6Header consistent with Ipv4Header naming.
+- (internet) New functions SetAddress () and GetAddress () are added, corresponding to SetLocal () and GetLocal () respectively in Ipv4InterfaceAddress to keep consistency with Ipv6InterfaceAddress.
+- (nix-vector-routing) Support for IPv6 Nix-Vector routing. Existing nix-simple and nms-p2p-nix examples are available in IPv6 as well.
+- (nix-vector-routing) ipv4-nix-vector-helper.h has been deprecated in favour of nix-vector-helper.h.
+- (nix-vector-routing) ipv4-nix-vector-routing.h has been deprecated in favour of nix-vector-routing.h.
+- (internet) Added new function IsInSameSubnet () in Ipv4InterfaceAddress similar to Ipv6InterfaceAddress::IsInSameSubnet (). It checks if the two Ipv4Address are in the same subnet.
+- (nix-vector-routing) Nix-Vector routing supports topologies with multiple WiFi networks using the same WiFi channel object.
+- (mobility) Add GroupMobilityHelper and demonstrate its use with a new program that configures the Reference Point Group Mobility model for a number of nodes.
+- (wifi) Add support for 11ax MU EDCA Parameter Set.
+- (wifi) MPDUs discarded because they became "old" (from the Block Ack agreement point of view) are now traced using the DroppedMpdu trace source of RegularWifiMac and with the WIFI_MAC_DROP_QOS_OLD_PACKET reason.
+
+Bugs fixed
+----------
+- (applications) #449, #453 - add correct receiving address to PacketSink traces for UDP.
+- (config-store) #443 - do not save obsolete attributes
+- (energy) #423 - SimpleDeviceEnergyModel calculation of consumed energy
+- (fd-net-device) #441 - Fix double dequeue on device stop
+- (internet) - Ipv4L3Protocol duplicate detection now accounts for sent packets, not just forwards.
+- (lte) !703 - Fix global-buffer-overflow when nprb is equal to zero
+- (mobility) - Initialize HierarchicalMobilityModel and avoid course change stream corruption
+- (nix-vector-routing) #450 - Avoid recalculation if path doesn't exist
+- (tcp) #407 - Align TcpCubic::GetSsThresh() with Linux
+- (tcp) #410 - Fix TcpWestwood bandwidth estimation bug
+- (traffic-control) #258 - Avoid overflow, divide-by-zero in TbfQueueDisc
+- (traffic-control) !706 - Fix FqPIE qdisc not using attributes
+- (wifi) - Always track interference when not locking on PPDU
+
 Release 3.34
 =============
 
@@ -25,13 +95,13 @@
 - Python 3.6 or later
 - (macOS only) Xcode 10.1 or later
 
-+This release has been tested on the following systems:
-+- Fedora 33 with g++-10.2.1 and clang++-11.0.0; Python 3.9.2
-+- Ubuntu 21.04 with g++-11.1.0 and Python 3.9.5
-+- Ubuntu 20.04 with g++-9.3.0 and Python 3.8.5
-+- Ubuntu 18.04 with g++-7.5.0 and Python 3.6.9
-+- macOS 10.15.7 (Catalina) with Xcode 12.4 (Apple clang-1200.0.32.29, Python 3.9.1)
-+- macOS 10.13.6 (High Sierra) with Xcode 10.1 (Apple clang-1000.11.45.5, Python 3.7.1)
+This release has been tested on the following systems:
+- Fedora 33 with g++-10.2.1 and clang++-11.0.0; Python 3.9.2
+- Ubuntu 21.04 with g++-11.1.0 and clang++-12.0.0; Python 3.9.5
+- Ubuntu 20.04 with g++-9.3.0 and Python 3.8.5
+- Ubuntu 18.04 with g++-7.5.0 and Python 3.6.9
+- macOS 10.15.7 (Catalina) with Xcode 12.4 (Apple clang-1200.0.32.29, Python 3.9.1)
+- macOS 10.13.6 (High Sierra) with Xcode 10.1 (Apple clang-1000.11.45.5, Python 3.7.1)
 
 New user-visible features
 -------------------------
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/antenna/bindings/modulegen__gcc_ILP32.py ns-3.35/src/antenna/bindings/modulegen__gcc_ILP32.py
--- ns-3.34/src/antenna/bindings/modulegen__gcc_ILP32.py	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/antenna/bindings/modulegen__gcc_ILP32.py	2021-10-01 13:26:47.000000000 -0700
@@ -833,6 +833,11 @@
                    'double', 
                    [], 
                    is_const=True)
+    ## vector.h (module 'core'): double ns3::Vector2D::GetLengthSquared() const [member function]
+    cls.add_method('GetLengthSquared', 
+                   'double', 
+                   [], 
+                   is_const=True)
     ## vector.h (module 'core'): ns3::Vector2D::x [variable]
     cls.add_instance_attribute('x', 'double', is_const=False)
     ## vector.h (module 'core'): ns3::Vector2D::y [variable]
@@ -860,6 +865,11 @@
                    'double', 
                    [], 
                    is_const=True)
+    ## vector.h (module 'core'): double ns3::Vector3D::GetLengthSquared() const [member function]
+    cls.add_method('GetLengthSquared', 
+                   'double', 
+                   [], 
+                   is_const=True)
     ## vector.h (module 'core'): ns3::Vector3D::x [variable]
     cls.add_instance_attribute('x', 'double', is_const=False)
     ## vector.h (module 'core'): ns3::Vector3D::y [variable]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/antenna/bindings/modulegen__gcc_LP64.py ns-3.35/src/antenna/bindings/modulegen__gcc_LP64.py
--- ns-3.34/src/antenna/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/antenna/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:47.000000000 -0700
@@ -833,6 +833,11 @@
                    'double', 
                    [], 
                    is_const=True)
+    ## vector.h (module 'core'): double ns3::Vector2D::GetLengthSquared() const [member function]
+    cls.add_method('GetLengthSquared', 
+                   'double', 
+                   [], 
+                   is_const=True)
     ## vector.h (module 'core'): ns3::Vector2D::x [variable]
     cls.add_instance_attribute('x', 'double', is_const=False)
     ## vector.h (module 'core'): ns3::Vector2D::y [variable]
@@ -860,6 +865,11 @@
                    'double', 
                    [], 
                    is_const=True)
+    ## vector.h (module 'core'): double ns3::Vector3D::GetLengthSquared() const [member function]
+    cls.add_method('GetLengthSquared', 
+                   'double', 
+                   [], 
+                   is_const=True)
     ## vector.h (module 'core'): ns3::Vector3D::x [variable]
     cls.add_instance_attribute('x', 'double', is_const=False)
     ## vector.h (module 'core'): ns3::Vector3D::y [variable]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/antenna/model/phased-array-model.h ns-3.35/src/antenna/model/phased-array-model.h
--- ns-3.34/src/antenna/model/phased-array-model.h	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/antenna/model/phased-array-model.h	2021-10-01 13:26:47.000000000 -0700
@@ -55,7 +55,7 @@
 
   /**
    * Returns the horizontal and vertical components of the antenna element field
-   * pattern at the specified direction. Only vertical polarization is considered.
+   * pattern at the specified direction. Single polarization is considered.
    * \param a the angle indicating the interested direction
    * \return a pair in which the first element is the horizontal component
    *         of the field pattern and the second element is the vertical
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/antenna/model/uniform-planar-array.cc ns-3.35/src/antenna/model/uniform-planar-array.cc
--- ns-3.34/src/antenna/model/uniform-planar-array.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/antenna/model/uniform-planar-array.cc	2021-10-01 13:26:47.000000000 -0700
@@ -32,13 +32,7 @@
 
 
 UniformPlanarArray::UniformPlanarArray ()
-  : PhasedArrayModel (),
-    m_numColumns {1},
-    m_numRows {1},
-    m_disV {0.5},
-    m_disH {0.5},
-    m_alpha {0},
-    m_beta {0}
+  : PhasedArrayModel ()
 {}
 
 UniformPlanarArray::~UniformPlanarArray ()
@@ -78,12 +72,17 @@
     .AddAttribute ("BearingAngle",
                    "The bearing angle in radians",
                    DoubleValue (0.0),
-                   MakeDoubleAccessor (&UniformPlanarArray::m_alpha),
+                   MakeDoubleAccessor (&UniformPlanarArray::SetAlpha),
                    MakeDoubleChecker<double> (-M_PI, M_PI))
     .AddAttribute ("DowntiltAngle",
                    "The downtilt angle in radians",
                    DoubleValue (0.0),
-                   MakeDoubleAccessor (&UniformPlanarArray::m_beta),
+                   MakeDoubleAccessor (&UniformPlanarArray::SetBeta),
+                   MakeDoubleChecker<double> (-M_PI, M_PI))
+    .AddAttribute ("PolSlantAngle",
+                   "The polarization slant angle in radians",
+                   DoubleValue (0.0),
+                   MakeDoubleAccessor (&UniformPlanarArray::SetPolSlant),
                    MakeDoubleChecker<double> (-M_PI, M_PI))
   ;
   return tid;
@@ -127,6 +126,29 @@
   return m_numRows;
 }
 
+void
+UniformPlanarArray::SetAlpha (double alpha)
+{
+  m_alpha = alpha;
+  m_cosAlpha = cos (m_alpha);
+  m_sinAlpha = sin (m_alpha);
+}
+
+void
+UniformPlanarArray::SetBeta (double beta)
+{
+  m_beta = beta;
+  m_cosBeta = cos (m_beta);
+  m_sinBeta = sin (m_beta);
+}
+
+void
+UniformPlanarArray::SetPolSlant (double polSlant)
+{
+  m_polSlant = polSlant;
+  m_cosPolSlant = cos (m_polSlant);
+  m_sinPolSlant = sin (m_polSlant);
+}
 
 void
 UniformPlanarArray::SetAntennaHorizontalSpacing (double s)
@@ -177,27 +199,32 @@
 
   // convert the theta and phi angles from GCS to LCS using eq. 7.1-7 and 7.1-8 in 3GPP TR 38.901
   // NOTE we assume a fixed slant angle of 0 degrees
-  double thetaPrime = std::acos (cos (m_beta) * cos (a.GetInclination ()) + sin (m_beta) * cos (a.GetAzimuth () - m_alpha) * sin (a.GetInclination ()));
-  double phiPrime = std::arg (std::complex<double> (cos (m_beta) * sin (a.GetInclination ()) * cos (a.GetAzimuth () - m_alpha) - sin (m_beta) * cos (a.GetInclination ()), sin (a.GetAzimuth () - m_alpha) * sin (a.GetInclination ())));
+  double cosIncl = cos (a.GetInclination ());
+  double sinIncl = sin (a.GetInclination ());
+  double cosAzim = cos (a.GetAzimuth () - m_alpha);
+  double sinAzim = sin (a.GetAzimuth () - m_alpha);
+  double thetaPrime = std::acos (m_cosBeta * cosIncl + m_sinBeta * cosAzim * sinIncl);
+  double phiPrime = std::arg (std::complex<double> (m_cosBeta * sinIncl * cosAzim - m_sinBeta * cosIncl, sinAzim * sinIncl));
   Angles aPrime (phiPrime, thetaPrime);
   NS_LOG_DEBUG (a << " -> " << aPrime);
 
-  // compute the antenna element field pattern in the vertical polarization using
-  // eq. 7.3-4 in 3GPP TR 38.901
-  // NOTE we assume vertical polarization, hence the field pattern in the
-  // horizontal polarization is 0
+  // compute the antenna element field patterns using eq. 7.3-4 and 7.3-5 in 3GPP TR 38.901,
+  // using the configured polarization slant angle (m_polSlant)
+  // NOTE: the slant angle (assumed to be 0) differs from the polarization slant angle
+  // (m_polSlant, given by the attribute), in 3GPP TR 38.901
   double aPrimeDb = m_antennaElement->GetGainDb (aPrime);
-  double fieldThetaPrime = pow (10, aPrimeDb / 20); // convert to linear magnitude
+  double fieldThetaPrime = pow (10, aPrimeDb / 20) * m_cosPolSlant; // convert to linear magnitude
+  double fieldPhiPrime = pow (10, aPrimeDb / 20) * m_sinPolSlant; // convert to linear magnitude
 
   // compute psi using eq. 7.1-15 in 3GPP TR 38.901, assuming that the slant
   // angle (gamma) is 0
-  double psi = std::arg (std::complex<double> (cos (m_beta) * sin (a.GetInclination ()) - sin (m_beta) * cos (a.GetInclination ()) * cos (a.GetAzimuth () - m_alpha), sin (m_beta) * sin (a.GetAzimuth () - m_alpha)));
+  double psi = std::arg (std::complex<double> (m_cosBeta * sinIncl - m_sinBeta * cosIncl * cosAzim, m_sinBeta * sinAzim));
   NS_LOG_DEBUG ("psi " << psi);
 
   // convert the antenna element field pattern to GCS using eq. 7.1-11
   // in 3GPP TR 38.901
-  double fieldTheta = cos (psi) * fieldThetaPrime;
-  double fieldPhi = sin (psi) * fieldThetaPrime;
+  double fieldTheta = cos (psi) * fieldThetaPrime - sin (psi) * fieldPhiPrime;
+  double fieldPhi = sin (psi) * fieldThetaPrime + cos (psi) * fieldPhiPrime;
   NS_LOG_DEBUG (RadiansToDegrees (a.GetAzimuth ()) << " " << RadiansToDegrees (a.GetInclination ()) << " " << fieldTheta * fieldTheta + fieldPhi * fieldPhi);
 
   return std::make_pair (fieldPhi, fieldTheta);
@@ -218,9 +245,9 @@
   // convert the coordinates to the GCS using the rotation matrix 7.1-4 in 3GPP
   // TR 38.901
   Vector loc;
-  loc.x = cos (m_alpha) * cos (m_beta) * xPrime - sin (m_alpha) * yPrime + cos (m_alpha) * sin (m_beta) * zPrime;
-  loc.y = sin (m_alpha) * cos (m_beta) * xPrime + cos (m_alpha) * yPrime + sin (m_alpha) * sin (m_beta) * zPrime;
-  loc.z = -sin (m_beta) * xPrime + cos (m_beta) * zPrime;
+  loc.x = m_cosAlpha * m_cosBeta * xPrime - m_sinAlpha * yPrime + m_cosAlpha * m_sinBeta * zPrime;
+  loc.y = m_sinAlpha * m_cosBeta * xPrime + m_cosAlpha * yPrime + m_sinAlpha * m_sinBeta * zPrime;
+  loc.z = -m_sinBeta * xPrime + m_cosBeta * zPrime;
   return loc;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/antenna/model/uniform-planar-array.h ns-3.35/src/antenna/model/uniform-planar-array.h
--- ns-3.34/src/antenna/model/uniform-planar-array.h	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/antenna/model/uniform-planar-array.h	2021-10-01 13:26:47.000000000 -0700
@@ -33,7 +33,7 @@
  * \brief Class implementing Uniform Planar Array (UPA) model.
  *
  * \note the current implementation supports the modeling of antenna arrays
- * composed of a single panel and with single (vertical) polarization.
+ * composed of a single panel and with single (configured) polarization.
  */
 class UniformPlanarArray : public PhasedArrayModel
 {
@@ -49,14 +49,16 @@
    */
   virtual ~UniformPlanarArray (void);
 
-
-  // inherited from Object
+  /**
+   * \brief Get the type ID.
+   * \return The object TypeId.
+   */
   static TypeId GetTypeId (void);
 
 
   /**
    * Returns the horizontal and vertical components of the antenna element field
-   * pattern at the specified direction. Only vertical polarization is considered.
+   * pattern at the specified direction. Single polarization is considered.
    * \param a the angle indicating the interested direction
    * \return a pair in which the first element is the horizontal component
    *         of the field pattern and the second element is the vertical
@@ -119,6 +121,29 @@
    */
   uint32_t GetNumRows (void) const;
 
+  /**
+   * \brief Set the bearing angle
+   * This method sets the bearing angle and
+   * computes its cosine and sine
+   * \param alpha the bearing angle in radians
+   */
+  void SetAlpha (double alpha);
+
+  /**
+   * \brief Set the downtilt angle
+   * This method sets the downtilt angle and
+   * computes its cosine and sine
+   * \param beta the downtilt angle in radians
+   */
+  void SetBeta (double beta);
+
+  /**
+   * \brief Set the polarization slant angle
+   * This method sets the polarization slant angle and
+   * computes its cosine and sine
+   * \param polSlant the polarization slant angle in radians
+   */
+  void SetPolSlant (double polSlant);
 
   /**
    * Set the horizontal spacing for the antenna elements of the phased array
@@ -151,14 +176,19 @@
    */
   double GetAntennaVerticalSpacing (void) const;
 
-
-  uint32_t m_numColumns; //!< number of columns
-  uint32_t m_numRows; //!< number of rows
-  double m_disV; //!< antenna spacing in the vertical direction in multiples of wave length
-  double m_disH; //!< antenna spacing in the horizontal direction in multiples of wave length
-  double m_alpha; //!< the bearing angle in radians
-  double m_beta; //!< the downtilt angle in radians
-
+  uint32_t m_numColumns {1}; //!< number of columns
+  uint32_t m_numRows {1}; //!< number of rows
+  double m_disV {0.5}; //!< antenna spacing in the vertical direction in multiples of wave length
+  double m_disH {0.5}; //!< antenna spacing in the horizontal direction in multiples of wave length
+  double m_alpha {0.0}; //!< the bearing angle in radians
+  double m_cosAlpha {1.0}; //!< the cosine of alpha
+  double m_sinAlpha {0.0}; //!< the sine of alpha
+  double m_beta {0.0}; //!< the downtilt angle in radians
+  double m_cosBeta {1.0}; //!< the cosine of Beta
+  double m_sinBeta {0.0}; //!< the sine of Beta
+  double m_polSlant {0.0}; //!< the polarization slant angle in radians
+  double m_cosPolSlant {1.0}; //!< the cosine of polarization slant angle
+  double m_sinPolSlant {0.0}; //!< the sine polarization slant angle
 };
 
 } /* namespace ns3 */
